#ifndef CLEDCONTROLLERPHYSICALSTRIP_H
#define CLEDCONTROLLERPHYSICALSTRIP_H

#include "LEDHAL.h"

class CLEDControllerPhysicalStrip : public LEDHAL {
  public:
    CLEDControllerPhysicalStrip(CLEDController* _controller, char* _ledName) :
      LEDHAL(_ledName, true), controller(_controller) {}

      uint16_t getNumLEDs() { return controller->size(); }
      CRGB getColor(int16_t pixel) { return controller->leds()[pixel]; }
      void setColor(int16_t pixel, CRGB color) { controller->leds()[pixel] = color; }

  protected:
    void updateLEDs() { controller->showLeds(); }

  
  private:
    CLEDController*
      controller;
};

#endif