#ifndef COLLISIONMATRIX_H
#define COLLISIONMATRIX_H

#include "MatrixAnimation.h"

enum CollisionType {
  HORIZONTAL_COLLISION,
  VERTICAL_COLLISION
};

class CollisionMatrix : public MatrixAnimation {
  public:
    CollisionMatrix(LEDHAL2D* _matrix, char* _refName, long _updateTime, CRGB _color1,
      CRGB _color2, CollisionType _type) : MatrixAnimation(_matrix, _refName, _updateTime),
      color1(_color1), color2(_color2), type(_type), collisionInt(0) {}
    virtual ~CollisionMatrix() {}

    void initialize() {
      collisionInt = 0;
      resetTimer();
    }

    void execute();

    CollisionType getType() {
      return type;
    }

  private:
    uint16_t
      collisionInt;
    CRGB
      color1,
      color2;
    CollisionType
      type;
};

#endif