#include "ColorRandomizerMatrix.h"

void ColorRandomizerMatrix::execute() {
    if(fade && isFading) {
        CRGB color;

        if(colorRandomizerInt == 0) {
            for(uint16_t i = 0; i < type == ColorRandomizerType::HORIZONTAL_COLORRANDOMIZER ? matrix->getHeight() : matrix->getWidth(); i++) {
                if(type == ColorRandomizerType::HORIZONTAL_COLORRANDOMIZER) {
                    color = matrix->getColor(0, i);
                } else {
                    color = matrix->getColor(i, 0);
                }

                fadingValues[i].red = (ceil((float)color.red/scale));
                fadingValues[i].green = (ceil((float)color.green/scale));
                fadingValues[i].blue = (ceil((float)color.blue/scale));
            }

            colorRandomizerInt++;
        } else if(colorRandomizerInt > 0 && colorRandomizerInt < scale + 1) {
            for(uint16_t i = 0; i < type == ColorRandomizerType::HORIZONTAL_COLORRANDOMIZER ? matrix->getHeight() : matrix->getWidth(); i++) {
                if(type == ColorRandomizerType::HORIZONTAL_COLORRANDOMIZER) {
                    matrix->drawFastHLine(0, i, matrix->getWidth(), matrix->getColor(0, i) - fadingValues[i]);
                } else {
                    matrix->drawFastVLine(i, 0, matrix->getHeight(), matrix->getColor(i, 0) - fadingValues[i]);
                }
            }

            colorRandomizerInt++;
        } else {
            colorRandomizerInt = 0;
            isFading = false;
        }
    } else {
        uint8_t rand;

        for(uint16_t i = 0; i < type == ColorRandomizerType::HORIZONTAL_COLORRANDOMIZER ? matrix->getHeight() : matrix->getWidth(); i++) {
            rand = random(0, numColors);

            if(type == ColorRandomizerType::HORIZONTAL_COLORRANDOMIZER) {
                matrix->drawFastHLine(0, i, matrix->getWidth(), colors[rand]);
            } else {
                matrix->drawFastVLine(i, 0, matrix->getHeight(), colors[rand]);
            }
        }

        if(fade) {
            isFading = true;
        }
    }

    matrix->requestShow();
}