#include "ColorRandomizerStrip.h"

void ColorRandomizerStrip::execute() {
    if(fade && isFading) {
        CRGB color;

        if(colorRandomizerInt == 0) {
            for(uint16_t i = 0; i < strip->getNumLEDs(); i++) {
                color = strip->getColor(i);

                fadingValues[i].red = (ceil((float)color.red/scale));
                fadingValues[i].green = (ceil((float)color.green/scale));
                fadingValues[i].blue = (ceil((float)color.blue/scale));
            }

            colorRandomizerInt++;
        } else if(colorRandomizerInt > 0 && colorRandomizerInt < scale + 1) {
            for(uint16_t i = 0; i < strip->getNumLEDs(); i++) {
                strip->setColor(i, strip->getColor(i) - fadingValues[i]);
            }

            colorRandomizerInt++;
        } else {
            colorRandomizerInt = 0;
            isFading = false;
        }
    } else {
        uint8_t rand;

        for(uint16_t i = 0; i < strip->getNumLEDs(); i++) {
            rand = random(0, numColors);

            strip->setColor(i, colors[rand]);
        }

        if(fade) {
            isFading = true;
        }
    }

    strip->requestShow();
}