#include "CycloneHelper.h"

void CycloneHelper::updateAndRedraw(LEDHAL2D* matrix) {
    matrix->drawPixel(nextPoint.getX(), nextPoint.getY(), color);

    // This will create an ungodly number of stack allocations and destroys
    for(uint8_t i = 0; i < numberOfTails; i++) {
        if(!tailPoints[i].isOrigin()) {
            matrix->drawPixel(tailPoints[i].getX(), tailPoints[i].getY(), tailColors[numberOfTails - i - 1]);
        }
    }

    Point2D tempPoint = nextPoint;

    // This is risky, if the logic is wrong, this is infinite
    // Find the next position on the circle that actually is different
    do {
        currentDrawAngle += spinDirection;

        if(currentDrawAngle > 359) {
            currentDrawAngle = 0;
        } else if(currentDrawAngle < 0) {
            currentDrawAngle = 359;
        }

        tempPoint = Point2D(
            originX + (uint16_t) round(radius * cosf(currentDrawAngle)),
            originY + (uint16_t) round(radius * sinf(currentDrawAngle))
        );
    } while(tempPoint == nextPoint);

    //Slide all tailpoints back one
    for(uint8_t i = numberOfTails - 1; i >= 1; i--) {
        tailPoints[i] = tailPoints[i - 1];
    }

    // Point we just drew becomes the first tail point
    tailPoints[0] = nextPoint;

    // Point we just discovered becomes the next point to draw
    nextPoint = tempPoint;
}