#include "DecodingBitStream.h"

uint16_t DecodingBitStream::getCode()
{
  uint16_t returnCode;

  verifyEnoughBits();

  returnCode = bitBuffer & (int)(pow(2, numberOfBitsInCode) - 1);
  bitBuffer >>= numberOfBitsInCode;
  bitsAvailable -= numberOfBitsInCode;

  return returnCode;
}

void DecodingBitStream::verifyEnoughBits()
{
  while(bytesAvailable != 0 && (bitsAvailable <= 8 || bitsAvailable <= numberOfBitsInCode))
  {
    bitBuffer |= stream->read() << bitsAvailable;
    bitsAvailable += 8;
    bytesAvailable--;
  }
}

uint16_t DecodingBitStream::getNumberOfBitsToRepresentValue(uint16_t value)
{
  uint16_t count = 0;

  while(value > 0)
  {
    value >>= 1;
    count++;
  }

  return count;
}
