#include "FireworksMatrix.h"

void FireworksMatrix::initialize() {
  for(uint8_t i = 0; i < maxFireworks; i++) {
    fireworks[i].isActive = false;
  }

  uint8_t third = maxFireworks / 6;

  for(uint8_t i = 0; i < third; i++) {
    randomSeed(random(0, 100000000));

    fireworks[i].radius = random(1, maxRadius + 1);
    fireworks[i].currentRadius = 1;
    fireworks[i].xPos = random(fireworks[i].radius, matrix->getWidth() - fireworks[i].radius);
    fireworks[i].yPos = matrix->getHeight();
    fireworks[i].yMaxHeight = random(fireworks[i].radius, matrix->getHeight() - fireworks[i].radius);
    fireworks[i].color = colors[random(0, numColors)];
    fireworks[i].isActive = true;
  }

  resetTimer();
}

void FireworksMatrix::execute() {
  matrix->clearLEDs();

  uint8_t totalInactive = 0;

  for(uint8_t i = 0; i < maxFireworks; i++) {
    if(!fireworks[i].isActive) {
      totalInactive++;
    }
  }

  for(uint8_t i = 0; i < totalInactive; i++) {
    randomSeed(random(0, 100000000));

    if(random(0, 1000) > 500) {
      for(uint8_t j = 0; j < maxFireworks; j++) {
        if(!fireworks[j].isActive) {
          fireworks[j].radius = random(1, maxRadius + 1);
          fireworks[j].currentRadius = 1;
          fireworks[j].xPos = random(fireworks[j].radius, matrix->getWidth() - fireworks[j].radius);
          fireworks[j].yPos = matrix->getHeight();
          fireworks[j].yMaxHeight = random(fireworks[j].radius, matrix->getHeight() - fireworks[j].radius);
          fireworks[j].color = colors[random(0, numColors)];
          fireworks[j].isActive = true;
          break;
        }
      }
    }
  }

  for(uint8_t i = 0; i < maxFireworks; i++) {
    if(fireworks[i].isActive) {
      if(fireworks[i].yMaxHeight == fireworks[i].yPos && 
        fireworks[i].currentRadius == fireworks[i].radius) {
        
        fireworks[i].isActive = false;
      } else if(fireworks[i].yMaxHeight == fireworks[i].yPos && 
        fireworks[i].currentRadius < fireworks[i].radius) {

        matrix->drawCircle(fireworks[i].xPos, fireworks[i].yPos, fireworks[i].currentRadius,
          fireworks[i].color);
        fireworks[i].currentRadius++;
      } else if(fireworks[i].yPos > fireworks[i].yMaxHeight) {
        matrix->drawPixel(fireworks[i].xPos, fireworks[i].yPos, fireworks[i].color);
        fireworks[i].yPos--;
      }
    }
  }

  matrix->requestShow();
}