#include "RicochetMatrix.h"

void RicochetMatrix::initialize() {
  for(uint16_t i = 0; i < numBalls; i++) {
    if(balls[i] != NULL) {
      delete balls[i];
    }

    randomSeed(random(0, 10000000));
    balls[i] = new RicochetHelper(random(0, matrix->getWidth()), random(0, matrix->getHeight()),
      matrix->getWidth(), matrix->getHeight(), colors[random(0, numColors)]);
  }
}

void RicochetMatrix::execute() {
  matrix->clearLEDs();

  for(uint16_t i = 0; i < numBalls; i++) {
    balls[i]->updatePositions();

    matrix->drawPixel(balls[i]->getCurrentXPos(), balls[i]->getCurrentYPos(), 
      balls[i]->getCurrentColor());
  }

  matrix->requestShow();
}